<?php // $Revision: 1.9 $

/*
|---------------------------------------------------------------------------|
| Max Media Manager v0.1                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2004 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
|---------------------------------------------------------------------------|
$Id: maintenance-statistics.php 235 2004-05-20 14:50:29Z demian $
*/

// Consolidate the data from the adviews, adclicks and adconversions tables into the adstats table.

// The timeframes that are processed starts with the most recent hour processed from adstats,
//   and ends with the last completed hour in adviews.

$report = '';

// Process Statistics...
$report .= "==================================================\n";
$report .= "BATCH STATISTICS STARTED\n";
$report .= "==================================================\n\n";
$report .= "--------------------------------------------------\n";

$done = false;

while (!$done) {
    $time_query = '
        SELECT  DATE_FORMAT(DATE_ADD(statslastday, INTERVAL statslasthour HOUR), "%Y%m%d%H%i%s") AS start_timestamp,
                DATE_FORMAT(DATE_ADD(statslastday, INTERVAL statslasthour+1 HOUR),"%Y%m%d%H%i%s") AS end_timestamp,
                statslastday AS start_day,
                statslasthour AS start_hour,
                NOW() AS exact_time,
                DATE_FORMAT(NOW(), "%Y%m%d%H%i%s") AS exact_timestamp
         FROM ' . $conf['tbl_config'];
    $time_result = phpAds_dbQuery($time_query)
        or $report.= "Could not perform SQL: ".$time_query."\n";

    debug('start and end timestamps selected');

    if ($time_row = phpAds_dbFetchArray($time_result)) {
        $begin_timestamp = $time_row['start_timestamp'];
        $end_timestamp = $time_row['end_timestamp'];
        $day = $time_row['start_day'];
        $hour = $time_row['start_hour'];
        $exact_timestamp = $time_row['exact_timestamp'];
        $exact_time = $time_row['exact_time'];
        
        $report .= "Checking for statistics...  The current time is " . $exact_time . "\n";
        $report .= "\tThe last hour that statistics were compiled was up to " . $hour . " on " . $day . ".\n\n";

        if ($exact_timestamp >= $end_timestamp) {
            debug('current time is at least one hour after last batch job');
            $report .= "Processing statistics for hour ".$hour." on ".$day."...\n\n";
            if (!phpAds_checkStatsExist($day, $hour, $report)) {
                phpAds_processStats($begin_timestamp, $end_timestamp, $day, $hour, $report);
            } else {
                $report .= "Statistics already exist for hour " . $hour . " on " . $day . ".  Please delete the statistics if you would like to regenerate.\n";
            }
            // Now that everything is done, update the stats generation date/time.
            phpAds_logStatsDate($end_timestamp);
        } else {
            $done = true;
            debug('current time is not at least one hour after last batch job');
        }
    } else {
        $done = true;
    }
}

$report .= "No more statistics to compile.\n";

// Write the output to the user log.
phpAds_userlogAdd(phpAds_actionBatchStatistics, 0, $report);

function phpAds_processStats($begin_timestamp, $end_timestamp, $day, $hour)
{
    global $report;
    debug('we are running stats functions in phpAds_processStats()');
    // If we are rebuilding a particular hour,
    // then increment back any inventory to campaigns and delete the stats for this hour
    $regen = false; // Will build later...
    if ($regen) {
        $report .= "\t REGENERATING!!/n/n";
        phpAds_undoInventory($day, $hour);
        phpAds_deleteCompactStats($day, $hour);
    }
    // Count the total views for this hour
    phpAds_countViews($begin_timestamp, $end_timestamp, $day, $hour);
    // Count the total clicks for this hour
    phpAds_countClicks($begin_timestamp, $end_timestamp, $day, $hour);
    // Count the total conversions for this hour
    phpAds_countConversions($begin_timestamp, $end_timestamp, $day, $hour);
    // Decrement the campaigns with our new statistics
    phpAds_decrementCampaigns($day, $hour);
    // Clean up (if user wants...)
    phpAds_deleteVerboseStats($begin_timestamp, $end_timestamp);
    
}

function phpAds_countViews($begin_timestamp, $end_timestamp, $day, $hour)
{
    global $conf, $report;
    
    //Process views...
    debug('- running the 1st job: phpAds_countViews()');
    $num_views = 0;
    $time = time();
    $report .= "\tCounting the verbose views between ".$begin_timestamp." and ".$end_timestamp."...\n";
    $view_query = 'SELECT 
                    bannerid,
                    zoneid,
                    COUNT(*) AS views
                    FROM ' . $conf['tbl_adviews'] . '
                    WHERE t_stamp >= ' . $begin_timestamp . '
                    AND t_stamp < ' . $end_timestamp . '
                    GROUP BY bannerid, zoneid';
    $view_result = phpAds_dbQuery($view_query)
        or $report.= "Could not perform SQL: ".$view_query."\n";
    debug('counting the verbose views between ' . $begin_timestamp . ' and ' . $end_timestamp);

    while ($view_row = phpAds_dbFetchArray($view_result)) {
        $stat_query = 'INSERT INTO ' . $conf['tbl_adstats'] ." SET
                        day = '" . $day . "'," . '
                        hour = ' . $hour . ',
                        bannerid = ' . $view_row['bannerid'] . ',
                        zoneid = ' . $view_row['zoneid'] . ',
                        views = ' . $view_row['views'];
        $stat_result = phpAds_dbQuery($stat_query)
            or $report.= " Could not perform SQL: ".$stat_query."\n";
        debug('inserting data into adstats');

        if (phpAds_dbAffectedRows($stat_result) < 1) {
            debug('no rows were inserted');
            $stat_query = "UPDATE " . $conf['tbl_adstats'].
                            " SET views=views+".$view_row['views'].
                            " WHERE day='".$day."'".
                            " AND hour=".$hour.
                            " AND bannerid=".$view_row['bannerid'].
                            " AND zoneid=".$view_row['zoneid'];
            $stat_result = phpAds_dbQuery($stat_query)
                or $report.= " Could not perform SQL: ".$stat_query."\n";
        } else {
            debug('at least one row was inserted');
        }
        $num_views += $view_row['views'];
    }
    $report .= "\tCounted ".$num_views." views in ".(time()-$time)." seconds.\n";
}

function phpAds_countClicks($begin_timestamp, $end_timestamp, $day, $hour)
{
    global $conf, $report;
    //Process clicks...
    debug('- running the 2nd job: phpAds_countClicks()');
    $num_clicks = 0;
    $time = time();
    $report .= "\tCounting the verbose clicks between ".$begin_timestamp." and ".$end_timestamp."...\n";
    $click_query = "SELECT bannerid".
                    ",zoneid".
                    ",count(*) as clicks".
                    " FROM ".$conf['tbl_adclicks'].
                    " WHERE t_stamp>=".$begin_timestamp.
                    " AND t_stamp<".$end_timestamp.
                    " GROUP BY bannerid, zoneid";
    $click_result = phpAds_dbQuery($click_query)
        or $report.= "Could not perform SQL: ".$click_query."\n";
    
    while ($click_row = phpAds_dbFetchArray($click_result)) {
        $stat_query = "UPDATE ".$conf['tbl_adstats'].
                        " SET clicks=clicks+".$click_row['clicks'].
                        " WHERE day='".$day."'".
                        " AND hour=".$hour.
                        " AND bannerid=".$click_row['bannerid'].
                        " AND zoneid=".$click_row['zoneid'];
        $stat_result = phpAds_dbQuery($stat_query)
            or $report.= " Could not perform SQL: ".$stat_query."\n";
        
        if (phpAds_dbAffectedRows($stat_result) < 1) {
            $stat_query = "INSERT INTO ".$conf['tbl_adstats'].
                            " SET day='".$day."'".
                            ",hour=".$hour.
                            ",bannerid=".$click_row['bannerid'].
                            ",zoneid=".$click_row['zoneid'].
                            ",clicks=".$click_row['clicks'];
            $stat_result = phpAds_dbQuery($stat_query)
                or $report.= " Could not perform SQL: ".$stat_query."\n";
        }
        $num_clicks += $click_row['clicks'];
    }
    $report .= "\tCounted ".$num_clicks." clicks in ".(time()-$time)." seconds.\n";
}

function phpAds_countConversions($begin_timestamp, $end_timestamp, $day, $hour)
{
    global $conf, $report;
    debug('- running the 3rd job: phpAds_countConversions()');
    $time = time();

    $report .= "\tCounting the verbose conversions between ".$begin_timestamp." and ".$end_timestamp."...\n";
    
    // Create temporary conversions clicks table
    $sql = "
        CREATE TEMPORARY TABLE tmp_conversions_clicks
            (conversionid bigint(20) unsigned NOT NULL default '0',
            campaignid mediumint(9) NOT NULL default '0',
            bannerid mediumint(9) NOT NULL default '0',
            trackerid mediumint(9) NOT NULL default '0',
            userid varchar(32) NOT NULL default '',
            t_stamp timestamp(14) NOT NULL,
            host varchar(255) NOT NULL default '',
            country char(2) NOT NULL default '',
            logstats enum('y','n') default 'n',
            clickwindow mediumint(9) NOT NULL default '0',
            viewwindow mediumint(9) NOT NULL default '0')
    ";
    debug('- phpAds_countConversions() - Create temporary table tmp_conversions_clicks: Started');
    $res = phpAds_dbQuery($sql)
        or $report .= "Could not perform SQL: ".$sql."\n";
    debug('- phpAds_countConversions() - Create temporary table tmp_conversions_clicks: Ended');

    // Create temporary conversions clicks table
    $sql = "
        CREATE TEMPORARY TABLE tmp_conversions_views
            (conversionid bigint(20) unsigned NOT NULL default '0',
            campaignid mediumint(9) NOT NULL default '0',
            bannerid mediumint(9) NOT NULL default '0',
            trackerid mediumint(9) NOT NULL default '0',
            userid varchar(32) NOT NULL default '',
            t_stamp timestamp(14) NOT NULL,
            host varchar(255) NOT NULL default '',
            country char(2) NOT NULL default '',
            logstats enum('y','n') default 'n',
            clickwindow mediumint(9) NOT NULL default '0',
            viewwindow mediumint(9) NOT NULL default '0')
    ";
    debug('- phpAds_countConversions() - Create temporary table tmp_conversions_views: Started');
    $res = phpAds_dbQuery($sql)
        or $report .= "Could not perform SQL: ".$sql."\n";
    debug('- phpAds_countConversions() - Create temporary table tmp_conversions_views: Ended');

    // Create temporary conversions table
    $sql = "
        CREATE TEMPORARY TABLE tmp_conversions
            (conversionlogid mediumint(9) NOT NULL auto_increment,
            conversionid bigint(20) unsigned NOT NULL default '0',
            campaignid mediumint(9) NOT NULL default '0',
            trackerid mediumint(9) NOT NULL default '0',
            userid varchar(32) NOT NULL default '',
            t_stamp timestamp(14) NOT NULL,
            host varchar(255) NOT NULL default '',
            country char(2) NOT NULL default '',
            cnv_logstats enum('y','n') default 'n',
            cnv_clickwindow mediumint(9) NOT NULL default '0',
            cnv_viewwindow mediumint(9) NOT NULL default '0',
            action enum('view','click') default NULL,
            action_bannerid mediumint(9) NOT NULL default '0',
            action_zoneid mediumint(9) NOT NULL default '0',
            action_t_stamp timestamp(14) NOT NULL,
            action_host varchar(255) NOT NULL default '',
            action_source varchar(50) NOT NULL default '',
            action_country char(2) NOT NULL default '',
            PRIMARY KEY (conversionlogid))
    ";
    debug('- phpAds_countConversions() - Create temporary table: Started');
    $res = phpAds_dbQuery($sql)
        or $report .= "Could not perform SQL: ".$sql."\n";
    debug('- phpAds_countConversions() - Create temporary table: Ended');


    // Perform LOCKS
    // on the appropriate tables.
    //
    // BEWARE!!!
    //
    // The tables names specified with the "AS" statement in the lock MUST be the same as
    // the "AS" table names specified in the select!
    $sql = "
        LOCK TABLES
            {$conf['tbl_adconversions']} AS cnv READ,
            {$conf['tbl_adclicks']} AS c READ,
            {$conf['tbl_adviews']} AS v READ,
            {$conf['tbl_campaigns_trackers']} AS t READ,
            {$conf['tbl_banners']} AS b READ,
            tmp_conversions_clicks AS tcc WRITE,
            tmp_conversions_views AS tcv WRITE,
            tmp_conversions WRITE
    ";
    debug('- phpAds_countConversions() - Locking tables for conversions: Started');
    $res = phpAds_dbQuery($sql)
        or $report.= "Could not perform SQL: $sql\n";
    debug('- phpAds_countConversions() - Locking tables for conversions: Ended');

    // Create table of potential conversions for the click table
    $sql = "
        INSERT INTO tmp_conversions_clicks
        SELECT
            cnv.conversionid AS conversionid,
            b.campaignid AS campaignid,
            b.bannerid AS bannerid,
            cnv.trackerid AS trackerid,
            cnv.userid AS userid,
            cnv.t_stamp AS t_stamp,
            cnv.host AS host,
            cnv.country AS country,
            t.logstats AS logstats,
            t.clickwindow AS clickwindow,
            t.viewwindow AS viewwindow
        FROM
            {$conf['tbl_adconversions']} AS cnv,
            {$conf['tbl_campaigns_trackers']} AS t,
            {$conf['tbl_banners']} AS b
        WHERE
            t.trackerid=cnv.trackerid
            AND b.campaignid=t.campaignid
            AND cnv.userid != ''
            AND cnv.t_stamp >= $begin_timestamp
            AND cnv.t_stamp < $end_timestamp
            AND t.clickwindow > 0
    ";
    debug('- phpAds_countConversions() - Create temp table for click based conversions: Started');
    $res = phpAds_dbQuery($sql)
        or $report .= "Could not perform SQL: $sql\n";
    debug('- phpAds_countConversions() - Create temp table for click based conversions: Ended');

    // Create table of potential conversions for the view table
    $sql = "
        INSERT INTO tmp_conversions_views
        SELECT
            cnv.conversionid AS conversionid,
            b.campaignid AS campaignid,
            b.bannerid AS bannerid,
            cnv.trackerid AS trackerid,
            cnv.userid AS userid,
            cnv.t_stamp AS t_stamp,
            cnv.host AS host,
            cnv.country AS country,
            t.logstats AS logstats,
            t.clickwindow AS clickwindow,
            t.viewwindow AS viewwindow
        FROM
            {$conf['tbl_adconversions']} AS cnv,
            {$conf['tbl_campaigns_trackers']} AS t,
            {$conf['tbl_banners']} AS b
        WHERE
            t.trackerid=cnv.trackerid
            AND b.campaignid=t.campaignid
            AND cnv.userid != ''
            AND cnv.t_stamp >= $begin_timestamp
            AND cnv.t_stamp < $end_timestamp
            AND t.viewwindow > 0
    ";
    debug('- phpAds_countConversions() - Create temp table for view based conversions: Started');
    $res = phpAds_dbQuery($sql)
        or $report .= "Could not perform SQL: $sql\n";
    debug('- phpAds_countConversions() - Create temp table for view based conversions: Ended');

    // Insert click conversions into temporary table
    $sql = "
        INSERT INTO tmp_conversions
            (conversionid,
            campaignid,
            trackerid,
            userid,
            t_stamp,
            host,
            country,
            cnv_logstats,
            cnv_clickwindow,
            cnv_viewwindow,
            action,
            action_bannerid,
            action_zoneid,
            action_t_stamp,
            action_host,
            action_source,
            action_country)
        SELECT
            tcc.conversionid AS conversionid,
            tcc.campaignid AS campaignid,
            tcc.trackerid AS trackerid,
            tcc.userid AS userid,
            tcc.t_stamp AS t_stamp,
            tcc.host AS host,
            tcc.country AS country,
            tcc.logstats AS cnv_logstats,
            tcc.clickwindow AS cnv_clickwindow,
            tcc.viewwindow AS cnv_viewwindow,
            'click' AS action,
            c.bannerid AS action_bannerid,
            c.zoneid AS action_zoneid,
            c.t_stamp AS action_t_stamp,
            c.host AS action_host,
            c.source AS action_source,
            c.country AS action_country
        FROM
            tmp_conversions_clicks AS tcc,
            {$conf['tbl_adclicks']} AS c
        WHERE
            tcc.userid=c.userid
            AND tcc.bannerid=c.bannerid
            AND tcc.t_stamp < DATE_ADD(c.t_stamp, INTERVAL tcc.clickwindow SECOND)
            AND tcc.t_stamp >= c.t_stamp
        ORDER BY
            c.t_stamp DESC
    ";
    debug('- phpAds_countConversions() - Insertion of click conversions: Started');
    $res = phpAds_dbQuery($sql)
        or $report .= "Could not perform SQL: $sql\n";
    debug('- phpAds_countConversions() - Insertion of click conversions: Ended');

    // Insert view conversions into temporary table
    $sql = "
        INSERT INTO tmp_conversions
            (conversionid,
            campaignid,
            trackerid,
            userid,
            t_stamp,
            host,
            country,
            cnv_logstats,
            cnv_clickwindow,
            cnv_viewwindow,
            action,
            action_bannerid,
            action_zoneid,
            action_t_stamp,
            action_host,
            action_source,
            action_country)
        SELECT
            tcv.conversionid AS conversionid,
            tcv.campaignid AS campaignid,
            tcv.trackerid AS trackerid,
            tcv.userid AS userid,
            tcv.t_stamp AS t_stamp,
            tcv.host AS host,
            tcv.country AS country,
            tcv.logstats AS cnv_logstats,
            tcv.clickwindow AS cnv_clickwindow,
            tcv.viewwindow AS cnv_viewwindow,
            'view' AS action,
            v.bannerid AS action_bannerid,
            v.zoneid AS action_zoneid,
            v.t_stamp AS action_t_stamp,
            v.host AS action_host,
            v.source AS action_source,
            v.country AS action_country
        FROM
            tmp_conversions_views AS tcv,
            {$conf['tbl_adviews']} AS v
        WHERE
            tcv.userid=v.userid
            AND tcv.bannerid=v.bannerid
            AND tcv.t_stamp < DATE_ADD(v.t_stamp, INTERVAL tcv.viewwindow SECOND)
            AND tcv.t_stamp >= v.t_stamp
        ORDER BY
            v.t_stamp DESC
    ";
    debug('- phpAds_countConversions() - Insertion of view conversions: Started');
    $res = phpAds_dbQuery($sql)
        or $report .= "Could not perform SQL: $sql\n";
    debug('- phpAds_countConversions() - Insertion of view conversions: Ended');

    // Unlock Tables
    $sql = "
        UNLOCK TABLES
    ";
    debug('- phpAds_countConversions() - Unlocking tables: Started');
    $res = phpAds_dbQuery($sql)
        or $report.= "Could not perform SQL: $sql\n";
    debug('- phpAds_countConversions() - Unlocking tables: Ended');

    $sql = "
        INSERT INTO {$conf['tbl_conversionlog']}
            (conversionid,
            campaignid,
            trackerid,
            userid,
            t_stamp,
            host,
            country,
            cnv_logstats,
            cnv_clickwindow,
            cnv_viewwindow,
            action,
            action_bannerid,
            action_zoneid,
            action_t_stamp,
            action_host,    
            action_source,
            action_country)
        SELECT
            conversionid,
            campaignid,
            trackerid,
            userid,
            t_stamp,
            host,
            country,
            cnv_logstats,
            cnv_clickwindow,
            cnv_viewwindow,
            action,
            action_bannerid,
            action_zoneid,
            action_t_stamp,
            action_host,
            action_source,
            action_country
        FROM
            tmp_conversions
        GROUP BY
            conversionid,
            campaignid
        ORDER BY
            conversionlogid
    ";
    debug('- phpAds_countConversions() - Insertion of temporary table results into conversion log: Started');
    $res = phpAds_dbQuery($sql)
        or $report.= "Could not perform SQL: ".$sql."\n";
    debug('- phpAds_countConversions() - Insertion of temporary table results into conversion log: Ended');

	/* Flag the latest conversion for each action, so that we dont get more than
	 * one conversion for each tracker hit
	 */
	
	// Start by getting all the conversionlogids with the latest timestamp for each conversionid
	$sql = 'CREATE TEMPORARY TABLE tmp_latest
                SELECT
                    conversionlogid, t_stamp
                FROM
                    '.$conf['tbl_conversionlog'].'
                WHERE
                    t_stamp >=    '.$begin_timestamp.'
                    AND t_stamp < '.$end_timestamp.'
                GROUP BY
                    conversionid
                HAVING
                    t_stamp = max(t_stamp)';
    debug('- phpAds_countConversions() - Get conversionlogid of latest conversions: Started');
    $res = phpAds_dbQuery($sql)
        or $report.= "Could not perform SQL: ".$sql."\n";
    debug('- phpAds_countConversions() - Get conversionlogid of latest conversions: Ended');

	// Update cnv_latest field on tbl_conversionlog table for each conversionlogid in the tmp table
	$sql = 'UPDATE
            '.$conf['tbl_conversionlog'].' as c,
                tmp_latest as t
            SET
                c.cnv_latest=1,
                c.t_stamp=c.t_stamp
            WHERE 
                c.conversionlogid=t.conversionlogid';
    debug('- phpAds_countConversions() - Set \'latest conversion\' flag: Started');
    $res = phpAds_dbQuery($sql)
        or $report.= "Could not perform SQL: ".$sql."\n";
    debug('- phpAds_countConversions() - Set \'latest conversion\' flag: Ended');

	$sql = 'DROP TEMPORARY TABLE tmp_latest';
    debug('- phpAds_countConversions() - Drop temporary table: Started');
    $res = phpAds_dbQuery($sql)
        or $report.= "Could not perform SQL: ".$sql."\n";
    debug('- phpAds_countConversions() - Drop temporary table: Ended');

    // Now, add up all of the conversions that we just logged and put them into adstats.
    // Process conversions...
    $num_conversions    = 0;
    $total_conversions  = 0;

    $conversion_query = "
                SELECT action_bannerid,
                    action_zoneid,
                    count(*) as conversions
                FROM " . $conf['tbl_conversionlog'] . "
                WHERE t_stamp >= " . $begin_timestamp . "
                    AND t_stamp < " . $end_timestamp . "
                    AND cnv_logstats = 'y'
					AND cnv_latest = 1
                GROUP BY action_bannerid, action_zoneid";
    debug('- phpAds_countConversions() - Adstats conversions query: Started');
    $conversion_result = phpAds_dbQuery($conversion_query)
        or $report.= "Could not perform SQL: ".$conversion_query."\n";
    debug('- phpAds_countConversions() - Adstats conversions query: Ended');

    $x = 1;
    while ($conversion_row = phpAds_dbFetchArray($conversion_result)) {
        $stat_query = " UPDATE " . $conf['tbl_adstats'] . "
                        SET conversions = conversions + " . $conversion_row['conversions'] . "
                        WHERE day = '" . $day . "'" . "
                        AND hour = " . $hour . "
                        AND bannerid = " . $conversion_row['action_bannerid'] . "
                        AND zoneid = " . $conversion_row['action_zoneid'];
        debug('- phpAds_countConversions() - Conversion query update: Started iteration ' . $x);
        $stat_result = phpAds_dbQuery($stat_query)
            or $report.= " Could not perform SQL: ".$stat_query."\n";
        debug('- phpAds_countConversions() - Conversion query update: Ended iteration ' . $x);

        if (phpAds_dbAffectedRows($stat_result) < 1) {
            $stat_query = " INSERT INTO " . $conf['tbl_adstats'] . "
                            SET day = '".$day."'". ",
                            hour = " . $hour . ",
                            bannerid = " . $conversion_row['action_bannerid']. ",
                            zoneid = " . $conversion_row['action_zoneid'] . ",
                            conversions = " . $conversion_row['conversions'];
            debug('- phpAds_countConversions() - Conversion query insert: Started iteration ' . $x);
            $stat_result = phpAds_dbQuery($stat_query)
                or $report.= " Could not perform SQL: ".$stat_query."\n";
            debug('- phpAds_countConversions() - Conversion query insert: Ended iteration ' . $x);
        }
        $num_conversions += $conversion_row['conversions'];
        $x++;
    }

    $conversion_query = "SELECT".
                    " COUNT(*) as conversions".
                    " FROM ".$conf['tbl_conversionlog'].
                    " WHERE t_stamp>=".$begin_timestamp.
                    " AND t_stamp<".$end_timestamp;
    debug('- phpAds_countConversions() - Select conversions: Started');
    $total_conversions = phpAds_dbQuery($conversion_query)
        or $report.= "Could not perform SQL: ".$conversion_query."\n";
    debug('- phpAds_countConversions() - Select conversions: Ended');

    $conversions = phpAds_dbFetchArray($total_conversions);

    // Update the variablevalues table with the conversionid of the conversion associated
    // with the variable, obtaining and then dropping locks on the appropriate tables.
    //
    // BEWARE!!!
    //
    // The tables names specified with the "AS" statement in the lock MUST be the same as
    // the "AS" table names specified in the update!
    //$variables_query = 'LOCK TABLES
    //                         '.$conf['tbl_adconversions'].' as c READ
    //                        ,'.$conf['tbl_variablevalues'].' as v WRITE';
    //debug('- phpAds_countConversions() - Lock tables for update variablevalues with conversionid associated with that variable: Started');
    //$variables_result = phpAds_dbQuery($variables_query)
    //    or $report.= "Could not perform SQL: ".$variables_query."\n";
    //debug('- phpAds_countConversions() - Lock tables for update variablevalues with conversionid associated with that variable: Ended');
                        
    $variables_query = 'UPDATE 
                             '.$conf['tbl_adconversions'].' as c
                            ,'.$conf['tbl_variablevalues'].' as v
                        SET
                            v.conversionid=c.conversionid
                        WHERE
                            v.local_conversionid=c.local_conversionid 
                            AND v.dbserver_ip=c.dbserver_ip 
                            AND c.t_stamp >= \''.$begin_timestamp.'\' 
                            AND c.t_stamp <  \''.$end_timestamp.'\' 
                            AND v.t_stamp >= \''.$begin_timestamp.'\' 
                            AND v.t_stamp <  \''.$end_timestamp.'\'';
    debug('- phpAds_countConversions() - Update variablevalues with conversionid associated with that variable: Started');
    $variables_result = phpAds_dbQuery($variables_query)
        or $report.= "Could not perform SQL: ".$variables_query."\n";
    debug('- phpAds_countConversions() - Update variablevalues with conversionid associated with that variable: Ended');
                        
    $report .= "\tLogged ".$num_conversions." conversions out of ".$conversions['conversions']." in ".(time()-$time)." seconds.\n\n";
}

function phpAds_decrementCampaigns($day, $hour)
{
    global $conf, $report;
    debug('- running the 4th job: phpAds_decrementCampaigns()');
    //Next, Subtract the number of views for a particular banner...
    $report .= "\tDecrementing High Priority Campaigns...\n";
    $time = time();
    $num_views = 0;
    $num_clicks = 0;
    $num_conversions = 0;
    
    // Get campaign information
    $campaign_query ='
        SELECT
            campaignid,
            clientid,
            campaignname,
            active,
            views,
            clicks,
            conversions,
            UNIX_TIMESTAMP(expire) AS expire_st,
            UNIX_TIMESTAMP(activate) AS activate_st,
            UNIX_TIMESTAMP(NOW()) AS current_st
        FROM ' . $conf['tbl_campaigns'];
    $campaign_result = phpAds_dbQuery($campaign_query)
        or $report.= "Could not perform SQL: ".$campaign_query."\n";
                    
    while ($campaign_row = phpAds_dbFetchArray($campaign_result)) {
        $views = $campaign_row['views'];
        $clicks = $campaign_row['clicks'];
        $conversions = $campaign_row['conversions'];
        $active = $campaign_row['active'];

        if (($views > 0) || ($clicks > 0) || ($conversions > 0)) {
            $count_query = "
                SELECT
                    SUM(views) AS sum_views,
                    SUM(clicks) AS sum_clicks,
                    SUM(conversions) AS sum_conversions
                FROM " . $conf['tbl_adstats'] . ', ' . $conf['tbl_banners'] . "
                WHERE ". $conf['tbl_banners'] . ".bannerid = " . $conf['tbl_adstats'] . ".bannerid". "
                AND "  . $conf['tbl_banners'] . ".campaignid = " . $campaign_row['campaignid'] . "
                AND day = '" . $day . "'". "
                AND hour = " . $hour;
            $count_result = phpAds_dbQuery($count_query)
                or $report.= "Could not perform SQL: ".$count_query."\n";

            if ($count_row = phpAds_dbFetchArray($count_result)) {
                if ($views > 0) {
                    $views -= $count_row['sum_views'];
                    if ($views < 1) {
                        $views = 0;
                        $active = 'f';
                    }
                    $num_views += $count_row['sum_views'];
                }
                if ($clicks > 0) {
                    $clicks -= $count_row['sum_clicks'];
                    if ($clicks < 1) {
                        $clicks = 0;
                        $active = 'f';
                    }
                    $num_clicks += $count_row['sum_clicks'];
                }
                if ($conversions > 0) {
                    $conversions -= $count_row['sum_conversions'];
                    if ($conversions < 1) {
                        $conversions = 0;
                        $active = 'f';
                    }
                    $num_conversions += $count_row['sum_conversions'];
                }
            }
        }

        // Check time status...
        if ( ($campaign_row['current_st'] < $campaign_row['activate_st']) ||
             ($campaign_row['current_st'] > $campaign_row['expire_st'] && $campaign_row['expire_st'] != 0) )
        {
            $active = 'f';
        }
        // Check to see if we need to log a change in activation status...
        if ($campaign_row['active'] != $active) {
            $report.= "Sending an email to the owner of campaign ".$campaign_row['campaignid']."\n";
            if ($active == 'f') {
                // Send deactivation emails...
                phpAds_deactivateMail($campaign_row);
            }
        }
        // Update campaign
        if ( ($views        != $campaign_row['views']) ||
             ($clicks       != $campaign_row['clicks']) ||
             ($conversions  != $campaign_row['conversions']) ||
             ($active       != $campaign_row['active']) )
        {
            $update_query =
                "UPDATE " . $conf['tbl_campaigns'].
                " SET views=" . $views.
                ",clicks=" . $clicks .
                ",conversions=" . $conversions .
                ",active='" . $active ."'".
                " WHERE campaignid=".$campaign_row['campaignid'];
            phpAds_dbQuery($update_query)
                or $report.= "Could not perform SQL: ".$update_query."\n";
            $report .= "\tChanging campaign ".$campaign_row['campaignid'].":\n";
            $report .= "\t\tViews:  from ".$campaign_row['views']." to ".$views."\n";
            $report .= "\t\tClicks:  from ".$campaign_row['clicks']." to ".$clicks."\n";
            $report .= "\t\tConversions:  from ".$campaign_row['conversions']." to ".$conversions."\n";
            $report .= "\t\tActive Status:  from ".$campaign_row['active']." to ".$active."\n\n";
        }
    }   
    
    $report .= "\tDecremented a total of ".$num_views." views, ".$num_clicks." clicks, and ".$num_conversions." conversions in ".(time()-$time)." seconds.\n\n\n";
}

function phpAds_deleteVerboseStats($begin_timestamp, $end_timestamp)
{
    global $conf, $report;
    debug('- running the 5th job: phpAds_deleteVerboseStats()');
    if ($conf['compact_stats']) {
        $time = time();
        $delete_query = "DELETE".
                        " FROM ".$conf['tbl_adviews'].
                        " WHERE t_stamp>=".$begin_timestamp.
                        " AND t_stamp<".$end_timestamp;
        phpAds_dbQuery($delete_query)
            or $report.= "Could not perform SQL: ".$delete_query."\n";
        
        $delete_query = "DELETE".
                        " FROM ".$conf['tbl_adclicks'].
                        " WHERE t_stamp>=".$begin_timestamp.
                        " AND t_stamp<".$end_timestamp;
        phpAds_dbQuery($delete_query)
            or $report.= "Could not perform SQL: ".$delete_query."\n";
        $report .= "Deleted verbose stats in ".(time()-$time)." seconds.\n";
    }
}

function phpAds_checkStatsExist($day, $hour)
{
    global $conf, $report;
    $exists = false;
    $stats_query =
        "SELECT COUNT(*) AS stat_count".
        " FROM ".$conf['tbl_adstats'].
        " WHERE day=".$day.
        " AND hour=".$hour
    ;
    $stats_result = phpAds_dbQuery($stats_query)
        or $report .= "Could not perform SQL: ".$stats_query."\n";

    if ($stats_row = phpAds_dbFetchArray($stats_result)) {
        $count = $stats_row['stat_count'];
        if ($count > 0) {
            $exists = true;
            debug('stats exist for ' . $day . ' at ' . $hour . ' o\'clock');
        } else {
            debug('stats do not exist for ' . $day . ' at ' . $hour . ' o\'clock');
        }
    }
    return $exists;
}

function phpAds_logStatsDate($end_timestamp)
{
    global $conf;
    
    $time_query =
        "UPDATE ".$conf['tbl_config'].
        " SET statslastday=".$end_timestamp.
        ",statslasthour=HOUR(".$end_timestamp.")"
    ;
    $time_result = phpAds_dbQuery($time_query);
}
?>
