#!/usr/bin/php -q
<?php // $Revision: 1.11 $

/*
|---------------------------------------------------------------------------|
| Max Media Manager v0.1                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2004 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
|---------------------------------------------------------------------------|
$Id: maintenance.php 235 2004-05-20 14:50:29Z demian $
*/

    //  start timing job
    $jobStartTime = time();

    // +---------------------------------------+
    // | define constants                      |
    // +---------------------------------------+

    define('phpAds_path', dirname(__FILE__));
    define('MYSQL_SCRIPT_DIR', '/home/mysql/scripts');
    define('DEBUG', false);

    //  db names
    define('phpAds_adminDb', 1);
    define('phpAds_rawDb', 2);

    //  usertypes
    define('phpAds_userDeliveryEngine', 1);
    define('phpAds_userMaintenance', 2);
    define('phpAds_userAdministrator', 3);
    define('phpAds_userAdvertiser', 4);
    define('phpAds_userPublisher', 5);

    //  actions
    define('phpAds_actionAdvertiserReportMailed', 0);
    define('phpAds_actionPublisherReportMailed', 1);
    define('phpAds_actionWarningMailed', 2);
    define('phpAds_actionDeactivationMailed', 3);
    define('phpAds_actionPriorityCalculation', 10);
    define('phpAds_actionPriorityAutoTargeting', 11);
    define('phpAds_actionDeactiveCampaign', 20);
    define('phpAds_actionActiveCampaign', 21);
    define('phpAds_actionAutoClean', 30);
    define('phpAds_actionBatchStatistics', 40);
    define('phpAds_installed', true);

    // +---------------------------------------+
    // | configure PHP                         |
    // +---------------------------------------+

    if (DEBUG) {
        ini_set('error_log', phpAds_path . '/log.txt');
        error_log('     '); error_log('================================');error_log('     ');
    }
    // Set time limit and ignore user abort
    if (!ini_get('safe_mode')) {
        @set_time_limit(300);
        @ignore_user_abort(true);
    }
    // Disable magic_quotes_runtime
    set_magic_quotes_runtime(0);

    // +---------------------------------------+
    // | load config and includes              |
    // +---------------------------------------+

    //  load config file
    $conf = parse_ini_file(phpAds_path . '/default.conf.ini', true);

    require_once phpAds_path . '/maintenance-common.php';
    require_once phpAds_path . '/translationStrings.php';

    debug('initial libs included correctly');

    // +---------------------------------------+
    // | check for lockfile                    |
    // +---------------------------------------+

    debug('checking for lockfile');
    $attempt = 0;
    //  don't start batch if lockfile detected
    while (file_exists(MYSQL_SCRIPT_DIR . '/HARVEST_LOCK')) {
        //  pause 30 secs
        sleep(30);
        debug('sleeping for 30 secs, iteration ' . $attempt);
        $attempt ++;
        if ($attempt > 2) {
            debug('more than 3 attempts, admin should be email here');
            //  email notification to admin
            exit;
        }
    }
    //  write lockfile so harvest will abort if it attempts to start during a mtce run
    debug('no lockfile exists, writing lockfile');
    $fh = fopen(MYSQL_SCRIPT_DIR . '/HARVEST_LOCK', 'w');


    // +---------------------------------------+
    // | db connect                            |
    // +---------------------------------------+

    phpAds_dbConnect();
    phpAds_LoadDbConfig();

    debug('db connection established, db config loaded');

    // +---------------------------------------+
    // | start maintenance                     |
    // +---------------------------------------+

    // Update the timestamp
    $res = phpAds_dbQuery('
        UPDATE ' . $conf['tbl_config'] . '
        SET maintenance_timestamp = UNIX_TIMESTAMP(NOW())
    ');

    debug('timestamp updated correctly in config table = ' . $res);

    // Run different maintenance tasks
    debug('starting mtce-statistics');
    require_once 'maintenance-statistics.php';

    // +---------------------------------------+
    // | if it's midnight, do additional tasks |
    // +---------------------------------------+

    if (date('H') == 0) {
        debug('starting midnight stats run'); 
        include_once 'maintenance-reports.php';
        include_once 'maintenance-activation.php';
        include_once 'maintenance-autotargeting.php';
        include_once 'maintenance-cleantables.php';
        include_once 'maintenance-optimization.php';
    }

    debug('calculating priorities'); 
    require_once 'maintenance-priority.php';

    debug('main script finished');

    // +---------------------------------------+
    // | remove lockfile                       |
    // +---------------------------------------+

    debug('remove lockfile');
    unlink(MYSQL_SCRIPT_DIR . '/HARVEST_LOCK');

    // +---------------------------------------+
    // | log results to mtce db                |
    // +---------------------------------------+

    debug('log results to db');
    //  get total job execution time
    $jobEndTime = time();
    $elapsedTime = $jobEndTime - $jobStartTime;

    //  mtce db
    // INSERT YOUR SPECIFIC INFORMATION HERE!!!
    $adminDbName = '';
    $adminDbHost = '';
    $adminDbUser = '';
    $adminDbPasswd = '';
    $tableMtce = '';

    // open connection to admin db
    $link = mysql_connect($adminDbHost, $adminDbUser, $adminDbPasswd) or die('Could not connect : ' . mysql_error()); 
    mysql_select_db($adminDbName) or die('Could not select database'); 

    $query = "
        INSERT INTO $tableMtce (
            maintenance_id, 
            executed_at, 
            duration)
        VALUES ('', 
            NOW() , 
            $elapsedTime)
        ";
    debug('mtce query : ' . $query);
    $result = mysql_query($query) or die('Query failed : ' . mysql_error());
    debug('mtce ends');
?>
